Index: cdr/cdr_odbc.c
===================================================================
--- cdr/cdr_odbc.c	(revision 76634)
+++ cdr/cdr_odbc.c	(working copy)
@@ -126,8 +126,7 @@
 	ODBC_res = SQLAllocHandle(SQL_HANDLE_STMT, ODBC_con, &ODBC_stmt);
 
 	if ((ODBC_res != SQL_SUCCESS) && (ODBC_res != SQL_SUCCESS_WITH_INFO)) {
-		if (option_verbose > 10)
-			ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: Failure in AllocStatement %d\n", ODBC_res);
+		ast_verb(11, "cdr_odbc: Failure in AllocStatement %d\n", ODBC_res);
 		SQLFreeHandle(SQL_HANDLE_STMT, ODBC_stmt);
 		odbc_disconnect();
 		ast_mutex_unlock(&odbc_lock);
@@ -141,8 +140,7 @@
 	ODBC_res = SQLPrepare(ODBC_stmt, (unsigned char *)sqlcmd, SQL_NTS);
 	
 	if ((ODBC_res != SQL_SUCCESS) && (ODBC_res != SQL_SUCCESS_WITH_INFO)) {
-		if (option_verbose > 10)
-			ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: Error in PREPARE %d\n", ODBC_res);
+		ast_verb(11, "cdr_odbc: Error in PREPARE %d\n", ODBC_res);
 		SQLFreeHandle(SQL_HANDLE_STMT, ODBC_stmt);
 		odbc_disconnect();
 		ast_mutex_unlock(&odbc_lock);
@@ -175,29 +173,23 @@
 	if (connected) {
 		res = odbc_do_query();
 		if (res < 0) {
-			if (option_verbose > 10)		
-				ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: Query FAILED Call not logged!\n");
-			if (option_verbose > 10)
-				ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: Reconnecting to dsn %s\n", dsn);
+			ast_verb(11, "cdr_odbc: Query FAILED Call not logged!\n");
+			ast_verb(11, "cdr_odbc: Reconnecting to dsn %s\n", dsn);
 			SQLDisconnect(ODBC_con);
 			res = odbc_init();
 			if (res < 0) {
-				if (option_verbose > 10)
-					ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: %s has gone away!\n", dsn);
+				ast_verb(11, "cdr_odbc: %s has gone away!\n", dsn);
 				odbc_disconnect();
 			} else {
-				if (option_verbose > 10)
-					ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: Trying Query again!\n");
+				ast_verb(11, "cdr_odbc: Trying Query again!\n");
 				res = odbc_do_query();
 				if (res < 0) {
-					if (option_verbose > 10)
-						ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: Query FAILED Call not logged!\n");
+					ast_verb(11, "cdr_odbc: Query FAILED Call not logged!\n");
 				}
 			}
 		}
 	} else {
-		if (option_verbose > 10)
-			ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: Query FAILED Call not logged!\n");
+		ast_verb(11, "cdr_odbc: Query FAILED Call not logged!\n");
 	}
 	SQLFreeHandle(SQL_HANDLE_STMT, ODBC_stmt);
 	ast_mutex_unlock(&odbc_lock);
@@ -208,29 +200,24 @@
 {
 	ast_mutex_lock(&odbc_lock);
 	if (connected) {
-		if (option_verbose > 10)
-			ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: Disconnecting from %s\n", dsn);
+		ast_verb(11, "cdr_odbc: Disconnecting from %s\n", dsn);
 		SQLFreeHandle(SQL_HANDLE_STMT, ODBC_stmt);
 		odbc_disconnect();
 	}
 	if (dsn) {
-		if (option_verbose > 10)
-			ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: free dsn\n");
+		ast_verb(11, "cdr_odbc: free dsn\n");
 		ast_free(dsn);
 	}
 	if (username) {
-		if (option_verbose > 10)
-			ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: free username\n");
+		ast_verb(11, "cdr_odbc: free username\n");
 		ast_free(username);
 	}
 	if (password) {
-		if (option_verbose > 10)
-			ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: free password\n");
+		ast_verb(11, "cdr_odbc: free password\n");
 		ast_free(password);
 	}
 	if (table) {
-		if (option_verbose > 10)
-			ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: free table\n");
+		ast_verb(11, "cdr_odbc: free table\n");
 		ast_free(table);
 	}
 
@@ -338,25 +325,19 @@
 		goto out;
 	}
 
-	if (option_verbose > 2) {
-		ast_verbose( VERBOSE_PREFIX_3 "cdr_odbc: dsn is %s\n",dsn);
-		if (username)
-		{
-			ast_verbose( VERBOSE_PREFIX_3 "cdr_odbc: username is %s\n",username);
-			ast_verbose( VERBOSE_PREFIX_3 "cdr_odbc: password is [secret]\n");
-		}
-		else
-			ast_verbose( VERBOSE_PREFIX_3 "cdr_odbc: retreiving username and password from odbc config\n");
-		ast_verbose( VERBOSE_PREFIX_3 "cdr_odbc: table is %s\n",table);
-	}
+	ast_verb(3, "cdr_odbc: dsn is %s\n",dsn);
+	if (username) {
+		ast_verb(3, "cdr_odbc: username is %s\n",username);
+		ast_verb(3, "cdr_odbc: password is [secret]\n");
+	} else
+		ast_verb(3, "cdr_odbc: retreiving username and password from odbc config\n");
+	ast_verb(3, "cdr_odbc: table is %s\n",table);
 	
 	res = odbc_init();
 	if (res < 0) {
 		ast_log(LOG_ERROR, "cdr_odbc: Unable to connect to datasource: %s\n", dsn);
-		if (option_verbose > 2) {
-			ast_verbose( VERBOSE_PREFIX_3 "cdr_odbc: Unable to connect to datasource: %s\n", dsn);
+		ast_verb(3, "cdr_odbc: Unable to connect to datasource: %s\n", dsn);
 		}
-	}
 	res = ast_cdr_register(name, ast_module_info->description, odbc_log);
 	if (res) {
 		ast_log(LOG_ERROR, "cdr_odbc: Unable to register ODBC CDR handling\n");
@@ -375,14 +356,12 @@
 	ODBC_res = SQLExecute(ODBC_stmt);
 	
 	if ((ODBC_res != SQL_SUCCESS) && (ODBC_res != SQL_SUCCESS_WITH_INFO)) {
-		if (option_verbose > 10)
-			ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: Error in Query %d\n", ODBC_res);
+		ast_verb(11, "cdr_odbc: Error in Query %d\n", ODBC_res);
 		SQLFreeHandle(SQL_HANDLE_STMT, ODBC_stmt);
 		odbc_disconnect();
 		return -1;
 	} else {
-		if (option_verbose > 10)
-			ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: Query Successful!\n");
+		ast_verb(11, "cdr_odbc: Query Successful!\n");
 		connected = 1;
 	}
 	return 0;
@@ -395,8 +374,7 @@
 	if (ODBC_env == SQL_NULL_HANDLE || connected == 0) {
 		ODBC_res = SQLAllocHandle(SQL_HANDLE_ENV, SQL_NULL_HANDLE, &ODBC_env);
 		if ((ODBC_res != SQL_SUCCESS) && (ODBC_res != SQL_SUCCESS_WITH_INFO)) {
-			if (option_verbose > 10)
-				ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: Error AllocHandle\n");
+			ast_verb(11, "cdr_odbc: Error AllocHandle\n");
 			connected = 0;
 			return -1;
 		}
@@ -404,8 +382,7 @@
 		ODBC_res = SQLSetEnvAttr(ODBC_env, SQL_ATTR_ODBC_VERSION, (void*)SQL_OV_ODBC3, 0);
 
 		if ((ODBC_res != SQL_SUCCESS) && (ODBC_res != SQL_SUCCESS_WITH_INFO)) {
-			if (option_verbose > 10)
-				ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: Error SetEnv\n");
+			ast_verb(11, "cdr_odbc: Error SetEnv\n");
 			SQLFreeHandle(SQL_HANDLE_ENV, ODBC_env);
 			connected = 0;
 			return -1;
@@ -414,8 +391,7 @@
 		ODBC_res = SQLAllocHandle(SQL_HANDLE_DBC, ODBC_env, &ODBC_con);
 
 		if ((ODBC_res != SQL_SUCCESS) && (ODBC_res != SQL_SUCCESS_WITH_INFO)) {
-			if (option_verbose > 10)
-				ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: Error AllocHDB %d\n", ODBC_res);
+			ast_verb(11, "cdr_odbc: Error AllocHDB %d\n", ODBC_res);
 			SQLFreeHandle(SQL_HANDLE_ENV, ODBC_env);
 			connected = 0;
 			return -1;
@@ -428,15 +404,13 @@
 	ODBC_res = SQLConnect(ODBC_con, (SQLCHAR*)dsn, SQL_NTS, (SQLCHAR*)username, SQL_NTS, (SQLCHAR*)password, SQL_NTS);
 
 	if ((ODBC_res != SQL_SUCCESS) && (ODBC_res != SQL_SUCCESS_WITH_INFO)) {
-		if (option_verbose > 10)
-			ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: Error SQLConnect %d\n", ODBC_res);
+		ast_verb(11, "cdr_odbc: Error SQLConnect %d\n", ODBC_res);
 		SQLFreeHandle(SQL_HANDLE_DBC, ODBC_con);
 		SQLFreeHandle(SQL_HANDLE_ENV, ODBC_env);
 		connected = 0;
 		return -1;
 	} else {
-		if (option_verbose > 10)
-			ast_verbose( VERBOSE_PREFIX_4 "cdr_odbc: Connected to %s\n", dsn);
+		ast_verb(11, "cdr_odbc: Connected to %s\n", dsn);
 		connected = 1;
 	}
 	return 0;
Index: cdr/cdr_adaptive_odbc.c
===================================================================
--- cdr/cdr_adaptive_odbc.c	(revision 76634)
+++ cdr/cdr_adaptive_odbc.c	(working copy)
@@ -155,8 +155,7 @@
 		ast_copy_string(tableptr->connection, connection, lenconnection + 1);
 		ast_copy_string(tableptr->table, table, lentable + 1);
 
-		if (option_verbose > 2)
-			ast_verbose(VERBOSE_PREFIX_3 "Found adaptive CDR table %s@%s.\n", tableptr->table, tableptr->connection);
+		ast_verb(3, "Found adaptive CDR table %s@%s.\n", tableptr->table, tableptr->connection);
 
 		while ((res = SQLFetch(stmt)) != SQL_NO_DATA && res != SQL_ERROR) {
 			char *cdrvar = "";
@@ -173,8 +172,7 @@
 				if (strcasecmp(var->value, columnname) == 0) {
 					char *tmp = ast_strdupa(var->name + 5);
 					cdrvar = ast_strip(tmp);
-					if (option_verbose > 2)
-						ast_verbose(VERBOSE_PREFIX_3 "Found alias %s for column %s in %s@%s\n", cdrvar, columnname, tableptr->table, tableptr->connection);
+					ast_verb(3, "Found alias %s for column %s in %s@%s\n", cdrvar, columnname, tableptr->table, tableptr->connection);
 					break;
 				}
 			}
@@ -541,8 +539,7 @@
 		sql2[lensql2 - 1] = ')';
 		strcat(sql + lensql, sql2);
 
-		if (option_verbose > 10)
-			ast_verbose(VERBOSE_PREFIX_4 "[%s]\n", sql);
+		ast_verb(11, "[%s]\n", sql);
 		/* No need to check the connection now; we'll handle any failure in prepare_and_execute */
 		obj = ast_odbc_request_obj(tableptr->connection, 0);
 		if (obj) {
Index: codecs/codec_lpc10.c
===================================================================
--- codecs/codec_lpc10.c	(revision 76634)
+++ codecs/codec_lpc10.c	(working copy)
@@ -270,8 +270,7 @@
 	for (var = ast_variable_browse(cfg, "plc"); var; var = var->next) {
 	       if (!strcasecmp(var->name, "genericplc")) {
 			lpc10tolin.useplc = ast_true(var->value) ? 1 : 0;
-			if (option_verbose > 2)
-			       ast_verbose(VERBOSE_PREFIX_3 "codec_lpc10: %susing generic PLC\n",
+			ast_verb(3, "codec_lpc10: %susing generic PLC\n",
 					lpc10tolin.useplc ? "" : "not ");
 		}
         }
Index: codecs/codec_g722.c
===================================================================
--- codecs/codec_g722.c	(revision 76634)
+++ codecs/codec_g722.c	(working copy)
@@ -174,8 +174,7 @@
 	for (var = ast_variable_browse(cfg, "plc"); var; var = var->next) {
 		if (!strcasecmp(var->name, "genericplc")) {
 			g722tolin.useplc = ast_true(var->value) ? 1 : 0;
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "codec_g722: %susing generic PLC\n",
+			ast_verb(3, "codec_g722: %susing generic PLC\n",
 					g722tolin.useplc ? "" : "not ");
 		}
 	}
Index: codecs/codec_alaw.c
===================================================================
--- codecs/codec_alaw.c	(revision 76634)
+++ codecs/codec_alaw.c	(working copy)
@@ -143,8 +143,7 @@
 	for (var = ast_variable_browse(cfg, "plc"); var; var = var->next) {
 		if (!strcasecmp(var->name, "genericplc")) {
 			alawtolin.useplc = ast_true(var->value) ? 1 : 0;
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "codec_alaw: %susing generic PLC\n", alawtolin.useplc ? "" : "not ");
+			ast_verb(3, "codec_alaw: %susing generic PLC\n", alawtolin.useplc ? "" : "not ");
 		}
 	}
 	ast_config_destroy(cfg);
Index: codecs/codec_speex.c
===================================================================
--- codecs/codec_speex.c	(revision 76634)
+++ codecs/codec_speex.c	(working copy)
@@ -389,23 +389,20 @@
 		if (!strcasecmp(var->name, "quality")) {
 			res = abs(atoi(var->value));
 			if (res > -1 && res < 11) {
-				if (option_verbose > 2)
-					ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: Setting Quality to %d\n",res);
+				ast_verb(3, "CODEC SPEEX: Setting Quality to %d\n",res);
 				quality = res;
 			} else 
 				ast_log(LOG_ERROR,"Error Quality must be 0-10\n");
 		} else if (!strcasecmp(var->name, "complexity")) {
 			res = abs(atoi(var->value));
 			if (res > -1 && res < 11) {
-				if (option_verbose > 2)
-					ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: Setting Complexity to %d\n",res);
+				ast_verb(3, "CODEC SPEEX: Setting Complexity to %d\n",res);
 				complexity = res;
 			} else 
 				ast_log(LOG_ERROR,"Error! Complexity must be 0-10\n");
 		} else if (!strcasecmp(var->name, "vbr_quality")) {
 			if (sscanf(var->value, "%f", &res_f) == 1 && res_f >= 0 && res_f <= 10) {
-				if (option_verbose > 2)
-					ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: Setting VBR Quality to %f\n",res_f);
+				ast_verb(3, "CODEC SPEEX: Setting VBR Quality to %f\n",res_f);
 				vbr_quality = res_f;
 			} else
 				ast_log(LOG_ERROR,"Error! VBR Quality must be 0-10\n");
@@ -413,70 +410,56 @@
 			ast_log(LOG_ERROR,"Error! ABR Quality setting obsolete, set ABR to desired bitrate\n");
 		} else if (!strcasecmp(var->name, "enhancement")) {
 			enhancement = ast_true(var->value) ? 1 : 0;
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: Perceptual Enhancement Mode. [%s]\n",enhancement ? "on" : "off");
+			ast_verb(3, "CODEC SPEEX: Perceptual Enhancement Mode. [%s]\n",enhancement ? "on" : "off");
 		} else if (!strcasecmp(var->name, "vbr")) {
 			vbr = ast_true(var->value) ? 1 : 0;
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: VBR Mode. [%s]\n",vbr ? "on" : "off");
+			ast_verb(3, "CODEC SPEEX: VBR Mode. [%s]\n",vbr ? "on" : "off");
 		} else if (!strcasecmp(var->name, "abr")) {
 			res = abs(atoi(var->value));
 			if (res >= 0) {
-				if (option_verbose > 2) {
 					if (res > 0)
-						ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: Setting ABR target bitrate to %d\n",res);
+					ast_verb(3, "CODEC SPEEX: Setting ABR target bitrate to %d\n",res);
 					else
-						ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: Disabling ABR\n");
-				}
+					ast_verb(3, "CODEC SPEEX: Disabling ABR\n");
 				abr = res;
 			} else 
 				ast_log(LOG_ERROR,"Error! ABR target bitrate must be >= 0\n");
 		} else if (!strcasecmp(var->name, "vad")) {
 			vad = ast_true(var->value) ? 1 : 0;
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: VAD Mode. [%s]\n",vad ? "on" : "off");
+			ast_verb(3, "CODEC SPEEX: VAD Mode. [%s]\n",vad ? "on" : "off");
 		} else if (!strcasecmp(var->name, "dtx")) {
 			dtx = ast_true(var->value) ? 1 : 0;
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: DTX Mode. [%s]\n",dtx ? "on" : "off");
+			ast_verb(3, "CODEC SPEEX: DTX Mode. [%s]\n",dtx ? "on" : "off");
 		} else if (!strcasecmp(var->name, "preprocess")) {
 			preproc = ast_true(var->value) ? 1 : 0;
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: Preprocessing. [%s]\n",preproc ? "on" : "off");
+			ast_verb(3, "CODEC SPEEX: Preprocessing. [%s]\n",preproc ? "on" : "off");
 		} else if (!strcasecmp(var->name, "pp_vad")) {
 			pp_vad = ast_true(var->value) ? 1 : 0;
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: Preprocessor VAD. [%s]\n",pp_vad ? "on" : "off");
+			ast_verb(3, "CODEC SPEEX: Preprocessor VAD. [%s]\n",pp_vad ? "on" : "off");
 		} else if (!strcasecmp(var->name, "pp_agc")) {
 			pp_agc = ast_true(var->value) ? 1 : 0;
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: Preprocessor AGC. [%s]\n",pp_agc ? "on" : "off");
+			ast_verb(3, "CODEC SPEEX: Preprocessor AGC. [%s]\n",pp_agc ? "on" : "off");
 		} else if (!strcasecmp(var->name, "pp_agc_level")) {
 			if (sscanf(var->value, "%f", &res_f) == 1 && res_f >= 0) {
-				if (option_verbose > 2)
-					ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: Setting preprocessor AGC Level to %f\n",res_f);
+				ast_verb(3, "CODEC SPEEX: Setting preprocessor AGC Level to %f\n",res_f);
 				pp_agc_level = res_f;
 			} else
 				ast_log(LOG_ERROR,"Error! Preprocessor AGC Level must be >= 0\n");
 		} else if (!strcasecmp(var->name, "pp_denoise")) {
 			pp_denoise = ast_true(var->value) ? 1 : 0;
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: Preprocessor Denoise. [%s]\n",pp_denoise ? "on" : "off");
+			ast_verb(3, "CODEC SPEEX: Preprocessor Denoise. [%s]\n",pp_denoise ? "on" : "off");
 		} else if (!strcasecmp(var->name, "pp_dereverb")) {
 			pp_dereverb = ast_true(var->value) ? 1 : 0;
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: Preprocessor Dereverb. [%s]\n",pp_dereverb ? "on" : "off");
+			ast_verb(3, "CODEC SPEEX: Preprocessor Dereverb. [%s]\n",pp_dereverb ? "on" : "off");
 		} else if (!strcasecmp(var->name, "pp_dereverb_decay")) {
 			if (sscanf(var->value, "%f", &res_f) == 1 && res_f >= 0) {
-				if (option_verbose > 2)
-					ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: Setting preprocessor Dereverb Decay to %f\n",res_f);
+				ast_verb(3, "CODEC SPEEX: Setting preprocessor Dereverb Decay to %f\n",res_f);
 				pp_dereverb_decay = res_f;
 			} else
 				ast_log(LOG_ERROR,"Error! Preprocessor Dereverb Decay must be >= 0\n");
 		} else if (!strcasecmp(var->name, "pp_dereverb_level")) {
 			if (sscanf(var->value, "%f", &res_f) == 1 && res_f >= 0) {
-				if (option_verbose > 2)
-					ast_verbose(VERBOSE_PREFIX_3 "CODEC SPEEX: Setting preprocessor Dereverb Level to %f\n",res_f);
+				ast_verb(3, "CODEC SPEEX: Setting preprocessor Dereverb Level to %f\n",res_f);
 				pp_dereverb_level = res_f;
 			} else
 				ast_log(LOG_ERROR,"Error! Preprocessor Dereverb Level must be >= 0\n");
Index: codecs/codec_g726.c
===================================================================
--- codecs/codec_g726.c	(revision 76634)
+++ codecs/codec_g726.c	(working copy)
@@ -904,8 +904,7 @@
 	for (var = ast_variable_browse(cfg, "plc"); var; var = var->next) {
 		if (!strcasecmp(var->name, "genericplc")) {
 			g726tolin.useplc = ast_true(var->value) ? 1 : 0;
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "codec_g726: %susing generic PLC\n",
+			ast_verb(3, "codec_g726: %susing generic PLC\n",
 					g726tolin.useplc ? "" : "not ");
 		}
 	}
Index: codecs/codec_ulaw.c
===================================================================
--- codecs/codec_ulaw.c	(revision 76634)
+++ codecs/codec_ulaw.c	(working copy)
@@ -156,8 +156,7 @@
 	for (var = ast_variable_browse(cfg, "plc"); var; var = var->next) {
 		if (!strcasecmp(var->name, "genericplc")) {
 			ulawtolin.useplc = ast_true(var->value) ? 1 : 0;
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "codec_ulaw: %susing generic PLC\n", ulawtolin.useplc ? "" : "not ");
+			ast_verb(3, "codec_ulaw: %susing generic PLC\n", ulawtolin.useplc ? "" : "not ");
 		}
 	}
 	ast_config_destroy(cfg);
Index: codecs/codec_adpcm.c
===================================================================
--- codecs/codec_adpcm.c	(revision 76634)
+++ codecs/codec_adpcm.c	(working copy)
@@ -359,8 +359,7 @@
 	for (var = ast_variable_browse(cfg, "plc"); var ; var = var->next) {
 		if (!strcasecmp(var->name, "genericplc")) {
 			adpcmtolin.useplc = ast_true(var->value) ? 1 : 0;
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "codec_adpcm: %susing generic PLC\n", adpcmtolin.useplc ? "" : "not ");
+			ast_verb(3, "codec_adpcm: %susing generic PLC\n", adpcmtolin.useplc ? "" : "not ");
 		}
 	}
 	ast_config_destroy(cfg);
Index: codecs/codec_gsm.c
===================================================================
--- codecs/codec_gsm.c	(revision 76634)
+++ codecs/codec_gsm.c	(working copy)
@@ -244,8 +244,7 @@
 	for (var = ast_variable_browse(cfg, "plc"); var; var = var->next) {
 	       if (!strcasecmp(var->name, "genericplc")) {
 		       gsmtolin.useplc = ast_true(var->value) ? 1 : 0;
-		       if (option_verbose > 2)
-			       ast_verbose(VERBOSE_PREFIX_3 "codec_gsm: %susing generic PLC\n", gsmtolin.useplc ? "" : "not ");
+			   ast_verb(3, "codec_gsm: %susing generic PLC\n", gsmtolin.useplc ? "" : "not ");
 	       }
 	}
 	ast_config_destroy(cfg);
Index: codecs/codec_zap.c
===================================================================
--- codecs/codec_zap.c	(revision 76634)
+++ codecs/codec_zap.c	(working copy)
@@ -323,8 +323,7 @@
 	for (var = ast_variable_browse(cfg, "plc"); var; var = var->next) {
 	       if (!strcasecmp(var->name, "genericplc")) {
 		       global_useplc = ast_true(var->value);
-		       if (option_verbose > 2)
-			       ast_verbose(VERBOSE_PREFIX_3 "codec_zap: %susing generic PLC\n",
+			   ast_verb(3, "codec_zap: %susing generic PLC\n",
 					   global_useplc ? "" : "not ");
 	       }
 	}
@@ -366,14 +365,13 @@
 		return 0;
 	}
 	for (info.tcnum = 0; !(res = ioctl(fd, ZT_TRANSCODE_OP, &info)); info.tcnum++) {
-		if (option_verbose > 1)
-			ast_verbose(VERBOSE_PREFIX_2 "Found transcoder '%s'.\n", info.name);
+		ast_verb(2, "Found transcoder '%s'.\n", info.name);
 		build_translators(&map, info.dstfmts, info.srcfmts);
 	}
 	close(fd);
 
-	if (!info.tcnum && (option_verbose > 1))
-		ast_verbose(VERBOSE_PREFIX_2 "No hardware transcoders found.\n");
+	if (!info.tcnum)
+		ast_verb(2, "No hardware transcoders found.\n");
 
 	for (x = 0; x < 32; x++) {
 		for (y = 0; y < 32; y++) {